#include <stdio.h>
#include <dlfcn.h>
#include <errno.h>
#include <sys/mman.h>
#include <pthread.h>

#include <string.h>

int Game_Main(const char  *path, const char *udn __attribute__ ((unused)))
{
	char szlogfile[256];
	FILE *msg;

	strcpy( szlogfile, path );
	strcat( szlogfile, "remote.log" );

	msg = fopen( szlogfile, "a+" );

	unsigned *handle=NULL;
	if ( (handle = dlopen(NULL,RTLD_LAZY | RTLD_GLOBAL)) == NULL )
	{
		fputs("Cannot open self!\n",msg);
		fputs (dlerror(), msg);
		fclose(msg);
		return 1;
	}

	// just for test we have proper instance
	unsigned *KeyInputBase_SendKey = dlsym(handle,"_ZN14SsKeyInputBase7SendKeyEi");

	unsigned *pKeyInputBase = dlsym(handle,"_ZN8SsObject14m_poObjectListE");
  
	if(pKeyInputBase == NULL)
	{
		fputs("Cannot find function!\n",msg);
		fputs(dlerror(), msg);
		fputs("\n",msg);
		fclose(msg);
		return 1;
	}

	if(KeyInputBase_SendKey == NULL )
	{
		fputs("Cannot find _ZN14SsKeyInputBase7SendKeyEi functions\n",msg);
		fputs(dlerror(), msg);
		fputs("\n",msg);
		fclose(msg);
		return 1;
	}

	dlclose(handle);

	/* Load remote library */
	char filename[64];
	strcpy(filename, path);
	strcat(filename,"remote.so");
	if ( (handle = dlopen( filename, RTLD_NOW | RTLD_LOCAL | RTLD_NODELETE)) == NULL )
	{
		fputs("Cannot open remote.so!\n",msg);
		fputs (dlerror(), msg);
		fputs("\n",msg);
		fclose(msg);
		return 1;
	}

	unsigned *remote_thread = dlsym(handle,"remote_thread");
	
	dlclose(handle);

	unsigned *pInstance = (unsigned *)(pKeyInputBase[2]);

	pKeyInputBase = (unsigned *)(*pInstance);
//	fprintf( msg, "*(pKeyInputBase[2]): 0x%08X\n", pKeyInputBase ); fflush( msg );

//	fprintf( msg, "KeyInputBase[1]: 0x%08X\n", pKeyInputBase[6] ); fflush( msg );

//	fprintf( msg, "KeyInputBase_SendKey: 0x%08X\n", KeyInputBase_SendKey ); fflush( msg );
	
	if ( pKeyInputBase[6] != (unsigned)KeyInputBase_SendKey )
	{
		fprintf( msg, "Bad instance?! Should be SsKeyInputBase..\n" );
	}
	else
	if ( remote_thread )
	{
		pthread_t	helper;
		pthread_create( &helper, NULL, (void *)remote_thread, pInstance );
		return 0;
	}
	else
	{
		fputs( "remote_thread NOT found..\n", msg );
	}

	fclose( msg );

	return 1;
}



